Attribute VB_Name = "modUtilita"
'================================================================
' Descrizione.....: Collezione di routines e costanti di utilita'
'                   per il "Poliedri".
' Nome dei Files..: modUtilita.bas
' Data............: 4/10/2002
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 sotto Windows NT.
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.virgilio.it/flanguasco/
'================================================================
'
Option Explicit
'
Public Const PI# = 3.14159265358979    ' 4# * Atn(1#)
Public Const PI2# = 2# * PI
Public Const PI_2# = PI / 2#           ' 90 in [Rad].
'
'--- GetLocale: ----------------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
    (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, _
    ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_SDECIMAL& = &HE
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDATE& = &H1D
Private Const LOCALE_STIME& = &H1E
Public Sub Cartesiane_Sferiche(ByVal x#, ByVal y#, ByVal z#, _
    ByRef Rho#, ByRef Theta#, ByRef Phi#)
'
'   Converte le coordinate da cartesiane a sferiche.
'    Rho = raggio vettore.
'    Theta = colatitudine (0 < Theta < PI).
'    Phi = longitudine (0 <= Phi < 2*PI).
'
    Rho = Sqr(x * x + y * y + z * z)
    If Rho > 0 Then
        Theta = Acos(z / Rho)
        Phi = Atan2(y, x)
    Else
        Theta = PI_2
        Phi = 0#
    End If
'
'
'
End Sub
Private Function Acos(ByVal x As Double) As Double
'
'   Calcola l' ArcoCoseno di x con -1 <= x <= 1.
'   Acos e' in radianti.
'
    If 0# < x And x <= 1# Then
        Acos = Atn(Sqr(1# - x * x) / x)
    ElseIf -1# <= x And x < 0# Then
        Acos = PI + Atn(Sqr(1# - x * x) / x)
    ElseIf x = 0# Then
        Acos = PI / 2#
    Else
        Err.Raise 5, "Acos Function", "Argomento illegale per Acos"
    End If
'
'
'
End Function
Public Sub Sferiche_Cartesiane(ByVal Rho#, ByVal Theta#, ByVal Phi#, _
    ByRef x#, ByRef y#, ByRef z#)
'
'   Converte le coordinate da sferiche a cartesiane.
'    Rho = raggio vettore.
'    Theta = colatitudine (0 < Theta < PI).
'    Phi = longitudine (0 <= Phi < 2*PI).
'
    x = Rho * Sin(Theta) * Cos(Phi)
    y = Rho * Sin(Theta) * Sin(Phi)
    z = Rho * Cos(Theta)
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$ _
    , Optional ByVal MAXFIL& = 5)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu, con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   MAXFIL e' il numero massimo di files recenti da ricordare:
'   puo' essere diverso a seconda dell' applicazione che usa
'   questa routine (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim a$, NuovoFile As Boolean
'
    If FileRec$ = "" Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        a$ = mnuRecenti(F).Caption
        If UCase$(Right$(a$, Len(a$) - 3)) = UCase$(FileRec$) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If F > FILN Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (FILN > 0)
'
    For I = F To 2 Step -1
        a$ = mnuRecenti(I - 1).Caption
        a$ = "&" & Trim$(Str$(I)) & " " & Right$(a$, Len(a$) - 3)
        mnuRecenti(I).Caption = a$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$ _
    , Optional ByVal MAXFIL& = 5, Optional ByVal VerificaFE As Boolean = True)
'
'   Legge dal Registry di Windows e se e' definito il "Product Name"
'   del progetto, i files recenti e li aggiunge al menu mnuRecenti().
'   Se VerificaFE = True verifica anche l' esistenza dei files da
'   aggiungere:
'
    Dim I&, FileRec$
'
    If App.ProductName = "" Then Exit Sub
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetSetting(App.ProductName, Sezione$, Str$(I), "")
        If FileRec$ <> "" Then
            If VerificaFE Then
                If FileExists(FileRec$) Then _
                    AggiornaFilesRecenti mnuRecenti, FileRec$, MAXFIL
            Else
                AggiornaFilesRecenti mnuRecenti, FileRec$, MAXFIL
            End If
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva nel Registry di Windows e se e' definito il "Product Name"
'   del progetto, i files recenti contenuti nel menu mnuRecenti():
'
    Dim I&, FileRec$
'
    If App.ProductName = "" Then Exit Sub
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveSetting App.ProductName, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub
Public Sub SalvaPosizioneForm(ByVal frmF As Form _
    , Optional ByVal Dimensioni As Boolean = False)
'
'   Salva, sul Registry di Window e se e' definito il
'   "Product Name" del progetto, la posizione finale
'   del Form frmF.  Da usare nell' evento frmF_Unload.
'   Se Dimensioni = True salva anche le dimensioni:
'
    If (frmF.WindowState <> vbMinimized) And (App.ProductName <> "") Then
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Left", frmF.Left
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Top", frmF.Top
'
        If Dimensioni Then
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Width", frmF.Width
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Sub LeggiPosizioneForm(ByVal frmF As Form, ByRef frmF_Left&, ByRef frmF_Top& _
    , Optional ByRef frmF_Width&, Optional ByRef frmF_Height&)
'
'   Legge, se e' definito il "Product Name" del progetto, la posizione
'   iniziale e le dimensioni  del Form frmF memorizzate sul Registry di Window.
'   Da usare nell' evento frmF_Load e con frmF.StartUpPosition = vbStartUpManual:
'
    If App.ProductName <> "" Then
        frmF_Left = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Left", 0))
        frmF_Top = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Top", 0))
'
        frmF_Width = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Width", Screen.Width))
        frmF_Height = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Height", Screen.Height))
    Else
        frmF_Left = 0
        frmF_Top = 0
'
        frmF_Width = frmF.Width
        frmF_Height = frmF.Height
    End If
'
'
'
End Sub
Public Function DATAN2(ByVal y#, ByVal x#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x
'   come implementata dal FORTRAN.
'   E':    -PI < DATAN2 <= PI.
'
    Select Case x
        Case Is > 0#
        DATAN2 = Atn(y / x)
'
        Case Is < 0#
        If y >= 0# Then
            DATAN2 = Atn(y / x) + PI
        ElseIf y < 0# Then
            DATAN2 = Atn(y / x) - PI
        End If
'
        Case Is = 0#
        DATAN2 = Sgn(y) * PI / 2#
    End Select
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA%, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
        Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer _
    , Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
        Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(Optional ByRef dS$, Optional ByRef MS$, _
    Optional ByRef GS$, Optional ByRef TS$)
'
'   Trova i separatori del sistema:
'    DS$:   separatore decimale.
'    MS$:   separatore delle migliaia.
'    GS$:   separatore dei giorni.
'    TS$:   separatore delle ore.
'
    dS$ = "  "
    MS$ = "  "
    GS$ = "  "
    TS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, dS$, Len(dS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_SDATE, GS$, Len(GS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STIME, TS$, Len(TS$)
'
    dS$ = Left$(dS$, 1)
    MS$ = Left$(MS$, 1)
    GS$ = Left$(GS$, 1)
    TS$ = Left$(TS$, 1)
'
'
'
End Sub

Public Function IsLoaded(ByVal frmF As Form) As Boolean
'
'   Ritorna True se il Form frmF e' gia' caricato in memoria:
'
    Dim I&
'
    For I = 0 To Forms.Count - 1
        If Forms(I) Is frmF Then
            IsLoaded = True
            Exit Function
        End If
    Next I
'
    IsLoaded = False
'
'
'
End Function
Public Function TabellaColori(ByVal NCol&) As Long()
'
'   Ritorna un vettore contenente NCol (2, 16, 256, 1280 o 1792) colori
'   in formato RGB.  La scala di colore, per NCOL = 1280, va' dal Viola
'   al Rosso; per NCOL = 1792, va' dal Bianco al Nero:
'
    Dim c&, C1&, C2&
    Dim R&, G&, b&
    ReDim TCol(0 To NCol - 1) As Long ' Tabella dei colori.
'
    Select Case NCol
        Case 2
        ' Prepara la tabella a 2 colori:
        TCol(0) = vbWhite
        TCol(1) = &H808080 ' Grigio.
'
        Case 16
        ' Prepara la tabella a 16 colori:
        For c = 0 To 15
            R = 255 * (Sqr(c) / Sqr(15))
            If c < 8 Then
                G = CLng(255 * (Sqr(c) / Sqr(7)))
            Else
                G = CLng(255 * (Sqr(15 - c) / Sqr(7)))
            End If
            b = 255 * (1! - Sqr(c) / Sqr(15))
'
            TCol(c) = RGB(R, G, b)
        Next c
'
        Case 256
        ' Prepara la tabella a 256 colori:
        For c = 0 To 255
            R = 255 * (Sqr(c) / Sqr(255))
            If c < 128 Then
                G = CLng(255 * (Sqr(c) / Sqr(127)))
            Else
                G = CLng(255 * (Sqr(255 - c) / Sqr(127)))
            End If
            b = 255 * (1! - Sqr(c) / Sqr(255))
'
            TCol(c) = RGB(R, G, b)
        Next c
'
        Case 1280
        ' Prepara la tabella a 1280 colori:
        c = 0
        For C1 = 0 To 4
            For C2 = 0 To 255
                R = Switch(C1 = 0, 255 - C2 _
                         , C1 = 1, 0 _
                         , C1 = 2, 0 _
                         , C1 = 3, C2 _
                         , C1 = 4, 255)
                G = Switch(C1 = 0, 0 _
                         , C1 = 1, C2 _
                         , C1 = 2, 255 _
                         , C1 = 3, 255 _
                         , C1 = 4, 255 - C2)
                b = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 _
                         , C1 = 2, 255 - C2 _
                         , C1 = 3, 0 _
                         , C1 = 4, 0)
'
                TCol(c) = RGB(R, G, b)
                c = c + 1
            Next C2
        Next C1
'
        Case 1792
        ' Prepara la tabella a 1792 colori:
        For C1 = 0 To 6
            For C2 = 0 To 255
                R = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 - C2 _
                         , C1 = 2, 0 _
                         , C1 = 3, 0 _
                         , C1 = 4, C2 _
                         , C1 = 5, 255 _
                         , C1 = 6, 255 - C2)
                G = Switch(C1 = 0, 255 - C2 _
                         , C1 = 1, 0 _
                         , C1 = 2, C2 _
                         , C1 = 3, 255 _
                         , C1 = 4, 255 _
                         , C1 = 5, 255 - C2 _
                         , C1 = 6, 0)
                b = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 _
                         , C1 = 2, 255 _
                         , C1 = 3, 255 - C2 _
                         , C1 = 4, 0 _
                         , C1 = 5, 0 _
                         , C1 = 6, 0)
'
                TCol(c) = RGB(R, G, b)
                c = c + 1
            Next C2
        Next C1
    End Select
'
    TabellaColori = TCol()
'
'
'
End Function
Public Function RandU(ByVal V_Min!, ByVal V_Max!) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme:
'
    RandU = V_Min + (V_Max - V_Min) * Rnd
'
'
'
End Function
Public Function Decima(dV#(), Optional ByRef lNV&) As Double()
'
'   Ritorna un vettore con gli elementi di dV()
'   ma senza i doppioni.
'   lNV e' il numero degli elementi rimasti:
'
    Dim I&, J&, Il&, Iu&, K&, dVT#()
'
    Il = LBound(dV)
    Iu = UBound(dV)
    I = Il - 1
    dVT() = dV()
'
    Do
        I = I + 1
        J = I + 1
        Do While J <= Iu
            If dVT(I) = dVT(J) Then
                For K = J To Iu - 1
                    dVT(K) = dVT(K + 1)
                Next K
                Iu = Iu - 1
            Else
                J = J + 1
            End If
        Loop
    Loop While I < Iu
'
    lNV = Iu - Il + 1
    ReDim Preserve dVT(Il To Iu)
'
    Decima = dVT()
'
'
'
End Function
Public Sub QuickSort(ByRef ValTab() As Double, ByVal Low&, ByVal High&, _
    Optional ByVal Verso& = -1)
'
'   Routine QuickSort:
'    ValTab():  Vettore che si vuole ordinare.
'    Low:       Posizione iniziale della zona da ordinare.
'    High:      Posizione finale della zona da ordinare.
'    Verso:     Direzione dell' ordinamento:
'                > 0 -> dal minore al maggiore.
'                = 0 -> nessun ordinamento.
'                < 0 -> dal maggiore al minore.
'
    Dim RandIndex&, I&, J&, M$
    Dim ValTemp As Double   ' Tipo del vettore che si vuole ordinare.
    Dim Part As Double      ' Tipo della chiave di ordinamento.
'
    On Error GoTo QuickSort_ERR
    If Verso = 0 Then Exit Sub
'
    If Low < High Then
'
        If High - Low = 1 Then
            ' Only two elements in this subdivision; swap them
            ' if they are out of order, then end recursive calls:
            If ((Verso > 0) And (ValTab(Low) > ValTab(High))) _
            Or ((Verso < 0) And (ValTab(Low) < ValTab(High))) Then
                'SWAP ValTab(Low), ValTab(High)
                ValTemp = ValTab(Low)
                ValTab(Low) = ValTab(High)
                ValTab(High) = ValTemp
            End If
'
        Else
            ' Pick a pivot element, then move it to the end:
            RandIndex = (High + Low) / 2
            'SWAP ValTab(High), ValTab(RandIndex)
            ValTemp = ValTab(High)
            ValTab(High) = ValTab(RandIndex)
            ValTab(RandIndex) = ValTemp
            Part = ValTab(High)
'
            ' Move in from both sides towards the pivot element:
            Do
                I = Low: J = High
                Do While ((Verso > 0) And (I < J) And (ValTab(I) <= Part)) _
                Or ((Verso < 0) And (I < J) And (ValTab(I) >= Part))
                    I = I + 1
                Loop
                Do While ((Verso > 0) And (J > I) And (ValTab(J) >= Part)) _
                Or ((Verso < 0) And (J > I) And (ValTab(J) <= Part))
                    J = J - 1
                Loop
'
                If I < J Then
                    ' We haven't reached the pivot element; it means that two
                    ' elements on either side are out of order, so swap them:
                    'SWAP ValTab(I), ValTab(J)
                    ValTemp = ValTab(I)
                    ValTab(I) = ValTab(J)
                    ValTab(J) = ValTemp
                End If
'
            Loop While I < J
            ' Move the pivot element back to its proper place in the array:
            'SWAP ValTab(I), ValTab(High)
            ValTemp = ValTab(I)
            ValTab(I) = ValTab(High)
            ValTab(High) = ValTemp
'
            ' Recursively call the QuickSort procedure (pass the smaller
            ' subdivision first to use less stack space):
            If (I - Low) < (High - I) Then
                QuickSort ValTab(), Low, I - 1, Verso
                QuickSort ValTab(), I + 1, High, Verso
            Else
                QuickSort ValTab(), I + 1, High, Verso
                QuickSort ValTab(), Low, I - 1, Verso
            End If
        End If
    End If
'
'
QuickSort_ERR:
    If (Err <> 0) Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " QuickSort"
    End If
'
'
'
End Sub
Public Function CMDialog_Files(ByVal CMDialog As CommonDialog, ByVal Oper$, _
    ByVal Tipo$, ByVal Ext$, Optional ByVal DirNome$ = "", _
    Optional ByVal FileNome$ = "", Optional ByVal Titolo$ = "") As String
'
'   Imposta i valori di una finestra per la gestione dei Files
'   e ritorna il nome completo del File scelto.
'   La gestione degli errori (e.g. cdlCancel) va' fatta nella
'   routine chiamante.
'
'   Parametri:
'    CMDialog:  e' il controllo Common Dialog che si intende usare.
'    Oper$:     operazione da eseguire (solo "Save" o "Open").
'    Tipo$:     tipo dei files da proporre (e.g. "Filtri IIR").
'    Ext$:      estensioni dei files da proporre (e.g. "*.dat[;*.txt]").
'    DirNome$:  Folder di default.
'    FileNome$: nome del File di default.
'    Titolo$:   titolo della finestra.
'
    Dim Filter$
'
    If Oper$ <> "Open" And Oper$ <> "Save" Then Err.Raise 5
'
    ' Prepara ed imposta tipo ed estensioni dei
    ' files da proporre:
    Filter$ = Tipo$ & " (" & Ext$ & ")|" & Ext$ & "|"
    Filter$ = Filter$ & "Tutti i Files (*.*)|*.*"
    CMDialog.Filter = Filter$
    CMDialog.FilterIndex = 1
'
    ' Imposta il Folder di default:
    If DirNome$ <> "" Then
        CMDialog.InitDir = DirNome$
    Else
        CMDialog.InitDir = App.Path
    End If
'
    ' Imposta il File Name di default:
    If FileNome$ <> "" Then
        CMDialog.FileName = FileNome$
    Else
        If Oper$ = "Open" Then
            CMDialog.FileName = ""
        ElseIf Oper$ = "Save" Then
            CMDialog.FileName = Left$(Ext$, 5)
        End If
    End If
'
    ' Scrive il titolo della finestra:
    CMDialog.DialogTitle = " " & Titolo$
'
    ' Controlla l' esistenza del File, chiede conferma
    ' se File Already Exists, nasconde la casella Read Only:
    CMDialog.Flags = cdlOFNFileMustExist + cdlOFNOverwritePrompt _
                   + cdlOFNHideReadOnly
    ' e permette il Cancel:
    CMDialog.CancelError = True
'
    ' Apre la finestra con
    ' l' operazione richiesta:
    If Oper$ = "Open" Then
        CMDialog.ShowOpen
    ElseIf Oper$ = "Save" Then
        CMDialog.ShowSave
    End If
'
    CMDialog_Files = CMDialog.FileName
'
'
'
End Function
Public Function DMIN1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vDMin > vD(J) Then vDMin = vD(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Function DMAX1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMAX1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If vDMax < vD(J) Then vDMax = vD(J)
    Next J
'
    DMAX1 = CDbl(vDMax)
'
'
'
End Function
Public Function Quadro(ByVal Foglio As PictureBox, _
    ByVal x0!, ByVal xn!, ByVal y0!, ByVal yn!, _
    Optional ByVal FormatVX$ = "#0.0##", _
    Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal Npx& = 1, Optional PxN_X!, Optional PxN_Y!, _
    Optional ByVal Titolo$ = "", _
    Optional ByVal UnitaX$ = "", _
    Optional ByVal UnitaY$ = "", _
    Optional ByVal AutoRed As Boolean = False) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'    Foglio:    PictureBox da scalare.
'    X0:        Valore minimo di ascissa da rappresentare.
'    Xn:        Valore massimo di ascissa da rappresentare.
'               Deve essere X0 < Xn.
'    Y0:        Valore minimo di ordinata da rappresentare.
'    Yn:        Valore massimo di ordinata da rappresentare.
'               Deve essere Y0 <= Yn.
'    FormatVX$: Stringa di formato dei valori sull' asse X.
'    FormatVY$: Stringa di formato dei valori sull' asse Y.
'    Npx:       N di Pixels di cui si vuole conoscere
'    PxN_X:      larghezza in [vbUser] e
'    PxN_Y:      altezza in [vbUser].
'    Titolo$:   Titolo del grafico.
'    UnitaX$:   Unita' (o titolo) dell' asse X.
'    UnitaY$:   Unita' (o titolo) dell' asse Y.
'    AutoRed:   Stato di Foglio.AutoRedraw dopo il disegno del quadro.
'
    Dim I&, XI!, D_X!, rrx!, YI!, D_Y!, rry!, Tx$
    Dim QxMin!, QxMax!, QyMin!, QyMax!, B0!, bn!, TxW!
    Dim TitL!, TitT!, TitW!, TitH!, Po4_X!, Po4_Y!
    Const Log10! = 2.30258509299405 ' Log(10#)
    Const DYMin! = 0.0001           ' Ampiezza min. della scala Y.
'
    On Error GoTo Quadro_ERR
    ' Verifica la correttezza delle scale:
    If x0 >= xn Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If y0 > yn Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
    ' Imposta i dati di Font dei valori
    ' degli assi:
    Foglio.FontName = "MS Sans Serif"
    Foglio.FontSize = 8
    Foglio.FontBold = False
'
    ' Calcola la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = xn - x0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If D_X / rrx > 10! Then rrx = rrx * 2!
    x0 = rrx * Int(Round(x0 / rrx, 3))
    xn = rrx * Ceil(Round(xn / rrx, 3))
    D_X = xn - x0
'
    ' Imposta una scala minima
    ' per l' asse Y:
    If yn - y0 < DYMin Then
        y0 = y0 - DYMin / 2!
        yn = yn + DYMin / 2!
    End If
'
    ' Calcola la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = yn - y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If D_Y / rry > 10! Then rry = rry * 2!
    y0 = rry * Int(Round(y0 / rry, 3))
    yn = rry * Ceil(Round(yn / rry, 3))
    D_Y = yn - y0
'
    ' Il bordo a destra dipende dalla
    ' presenza, o meno, di un' etichetta:
    If UnitaX$ = "" Then
        bn = D_X / 20!
    Else
        bn = D_X / 10!
    End If
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    TxW = Foglio.TextWidth(Format$(y0, FormatVY$) & " ")
    If TxW < Foglio.TextWidth(Format$(yn, FormatVY$) & " ") Then
        TxW = Foglio.TextWidth(Format$(yn, FormatVY$) & " ")
    End If
    B0 = TxW * (D_X + bn) / (Foglio.ScaleWidth - TxW)
    If B0 < D_X / 10! Then B0 = D_X / 10!
'
    ' Imposta i bordi orizzontali
    ' e verticali:
    QxMin = x0 - B0
    QxMax = xn + bn
    QyMin = y0 - D_Y / 10!
    QyMax = yn + D_Y / 7!
'
    ' Cancella il Foglio e imposta la scala:
    Foglio.Picture = LoadPicture("")
    Foglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
    ' La scalatura deve essere permanente:
    Foglio.AutoRedraw = True
    ' Calcola larghezza ed altezza di Npx pixels:
    PxN_X = Abs(Foglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(Foglio.ScaleY(Npx, vbPixels, vbUser))
    ' Calcola larghezza ed altezza di 4 points:
    Po4_X = Foglio.ScaleX(4, vbPoints, vbUser)
    Po4_Y = Foglio.ScaleY(4, vbPoints, vbUser)
'
    Foglio.DrawMode = vbCopyPen
    Foglio.DrawWidth = 1
    Foglio.DrawStyle = vbDash
    Foglio.ForeColor = vbGreen
    ' Traccia la griglia verticale e scrive
    ' i valori dell' asse X:
    For XI = x0 To xn + 0.1 * rrx Step rrx
        Foglio.Line (XI, y0)-(XI, yn), vbGreen
        Tx$ = Format$(XI, FormatVX$)
        ' Verifica che il formato scelto non
        ' induca ad errori di rappresentazione:
        If Abs(XI - Val(Tx$)) < rrx / 10 Then
            Foglio.CurrentX = XI - Foglio.TextWidth(Tx$) / 2!
            Foglio.CurrentY = y0 - D_Y / 70!
            Foglio.Print Tx$;
        End If
    Next XI
    ' Scrive l' etichetta dell' asse X:
    If UnitaX$ <> "" Then
        ' Etichetta tutta a destra:
        'Foglio.CurrentX = QxMax - Foglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        Foglio.CurrentX = (Foglio.CurrentX + QxMax - Foglio.TextWidth(UnitaX$)) / 2!
        Foglio.Print UnitaX$;
    End If
    ' Traccia l' asse Y:
    If (x0 <= 0!) And (0! <= xn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (0!, y0)-(0!, QyMax - D_Y / 30!), vbGreen
        Foglio.Line (0!, QyMax - D_Y / 30!) _
                   -(-Po4_X / 2!, Po4_Y + QyMax - D_Y / 30!), vbGreen
        Foglio.Line (0!, QyMax - D_Y / 30!) _
                   -(Po4_X / 2!, Po4_Y + QyMax - D_Y / 30!), vbGreen
    End If
'
    Foglio.DrawStyle = vbDash
    ' Traccia la griglia orizzontale e scrive
    ' i valori dell' asse Y:
    For YI = y0 To yn + 0.1 * rry Step rry
        Foglio.Line (x0, YI)-(xn, YI), vbGreen
        Tx$ = Format$(YI, FormatVY$)
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = YI - Foglio.TextHeight(Tx$) / 2!
        Foglio.Print Tx$;
    Next YI
    ' Scrive l' etichetta dell' asse Y:
    If UnitaY$ <> "" Then
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = QyMax
        Foglio.Print UnitaY$;
    End If
    ' Traccia l' asse X:
    If (y0 <= 0!) And (0! <= yn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (x0, 0!)-(QxMax - D_X / 30!, 0!), vbGreen
        Foglio.Line (QxMax - D_X / 30!, 0!) _
                   -(QxMax - D_X / 30! - Po4_X, -Po4_Y / 2!), vbGreen
        Foglio.Line (QxMax - D_X / 30!, 0!) _
                   -(QxMax - D_X / 30! - Po4_X, Po4_Y / 2!), vbGreen
    End If
'
    ' Scrive il titolo del grafico:
    If Titolo$ <> "" Then
        Foglio.FontSize = 12
        Foglio.FontBold = True
        Foglio.ForeColor = vbRed
'
        TitW = Foglio.TextWidth(Titolo$)
        TitH = Foglio.TextHeight(Titolo$)
        ' Verifica che il titolo stia tutto nel Foglio:
        If TitW <= Foglio.ScaleWidth Then
            TitL = (QxMin + QxMax - TitW) / 2!
        ' e se no' lo taglia:
        Else
            TitL = Foglio.ScaleLeft
            Tx$ = " . . . ."
            Titolo$ = Left$(Titolo$, Int(Len(Titolo$) * _
            (Foglio.ScaleWidth - Foglio.TextWidth(Tx$)) / TitW)) & Tx$
        End If
        TitT = QyMax
        ' Cancella l' area su cui andra' scritto il titolo:
        'Foglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), Foglio.BackColor, BF
        Foglio.CurrentX = TitL
        Foglio.CurrentY = TitT
        Foglio.Print Titolo$
    End If
'
    Foglio.DrawStyle = vbSolid
    Foglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err = 0)
    If Err <> 0 Then
        MsgBox Err.Description, vbCritical, Err.Source
    End If
'
'
'
End Function
Public Function Ceil(ByVal x As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If x = Int(x) Then
        Ceil = x
    Else
        Ceil = Int(x) + 1#
    End If
'
'
'
End Function
Public Function MAX0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MAX0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If vDMax < vD(J) Then vDMax = vD(J)
    Next J
'
    MAX0 = CLng(vDMax)
'
'
'
End Function
Public Function MIN0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If vDMin > vD(J) Then vDMin = vD(J)
    Next J
'
    MIN0 = CLng(vDMin)
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef PName$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'    Full$  = Nome completo del File.
'    PName$ = Path del File (con \ finale).
'    FName$ = Nome del File con Estensione.
'    Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Function Atan2(ByVal y#, ByVal x#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x su 4 Quadranti.
'   E':    0 <= Atan2 < 2 * PI.
'
    Select Case x
        Case Is > 0#
        If y >= 0# Then
            Atan2 = Atn(y / x)
        Else
            Atan2 = Atn(y / x) + PI2
        End If
'
        Case Is < 0#
        Atan2 = Atn(y / x) + PI
'
        Case Is = 0#
        Atan2 = Sgn(y) * PI / 2#
    End Select
'
'
'
End Function
Public Function DMINVAL(dVet#()) As Double
'
'   Ritorna il valore minimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMin#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMin = dVet(J1)
    For J = J1 + 1 To J2
        If dDMin > dVet(J) Then dDMin = dVet(J)
    Next J
'
    DMINVAL = dDMin
'
'
'
End Function
Public Function DMAXVAL(dVet#()) As Double
'
'   Ritorna il valore massimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMax#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMax = dVet(J1)
    For J = J1 + 1 To J2
        If dDMax < dVet(J) Then dDMax = dVet(J)
    Next J
'
    DMAXVAL = dDMax
'
'
'
End Function

Public Sub Triangoli(x#(), y#(), z#())
'
'
    Dim I&, NP&, PS() As Boolean
'
    NP = UBound(x)
    ReDim PS(1 To NP)
'
'
'
End Sub
